"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ms_1 = __importDefault(require("ms"));
function getConfig(cfg) {
    // default time options for swr
    const configBase = {
        retryInterval: ms_1.default('5s'),
        networkRetryInterval: ms_1.default('10s'),
        rateLimitedRetryInterval: ms_1.default('60s'),
        onFocusThrottle: ms_1.default('5s'),
        loadingTimeout: ms_1.default('3s')
    };
    if (typeof window !== 'undefined') {
        // client side: need to adjust swr options
        // based on the browser status
        // slow connection (<= 70Kbps)
        if (navigator.connection) {
            if (['slow-2g', '2g'].indexOf(navigator.connection.effectiveType) !== -1) {
                configBase.retryInterval = ms_1.default('10s');
                configBase.networkRetryInterval = ms_1.default('20s');
                configBase.loadingTimeout = ms_1.default('5s');
            }
        }
    }
    // override
    Object.assign(configBase, cfg);
    return configBase;
}
exports.default = getConfig;
